#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: changepass.cgi,v 1.1.1.1 2001/12/11 06:50:38 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut


  ###  Import our library routines.
  require 'userpass-lib.pl';


  ###  Define local variables.
  my ($old_password_HELP, $sync_smbpasswd_HELP);
  my ($new_password_1_HELP, $new_password_2_HELP);

  ###  Setup local variables.
  $old_password_HELP    =  &hlink("Old&nbsp;Password",
                                  "userpass_old_password", "help");
  $sync_smbpasswd_HELP  =  &hlink("Sync&nbsp;Windows&nbsp;Password",
                                  "userpass_smbpasswd", "help");
  $new_password_1_HELP  =  &hlink("New&nbsp;Password",
                                  "userpass_new_password_1", "help");
  $new_password_2_HELP  =  &hlink("New&nbsp;Password&nbsp;(Again)",
                                  "userpass_new_password_2", "help");


  ###  Print obligatory header.
  &header("User Authentication Management :: Change System Password", 0);


  ###  Print the HTML.
  print <<EOF;
<FORM ACTION="do_changepass.cgi" METHOD="POST">
<CENTER><TABLE BORDER=0 WIDTH="500" CELLPADDING=0 CELLSPACING=0>
  <TR $tb>
    <TD ALIGN="LEFT" COLSPAN="5"><DIV CLASS="ttitle"><B>Change Password</B></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="5"><DIV CLASS="nbody">Welcome to the password administration
      menu.  Here you can change your account password.  Please enter your old
      password in the first field and your new password in the next two fields.
      If the two new passwords match then your password will be changed and you
      will be logged out of the password changing area.
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="5">&nbsp;</TD> </TR>

  <TR $cb>
    <TD><DIV CLASS="nbody"><B>$old_password_HELP</TD>
    <TD><INPUT TYPE="PASSWORD" NAME="user_curpass" SIZE="10"></TD>
    <TD>&nbsp;</TD>
EOF


  ###  Only ask user to change smbpass if they have an entry in it.
  if (&DoesUserHaveSmbpassEntry($ENV{'REMOTE_USER'})) {
    print <<EOF;
    <TD COLSPAN="2"><DIV CLASS="nbody">
      <B>$sync_smbpasswd_HELP</B>&nbsp;<INPUT TYPE="CHECKBOX" NAME="sync_smbpasswd" CHECKED>
    </DIV></TD>
EOF
  }
  else {
    print "    <TD COLSPAN=\"2\"> &nbsp; </TD>\n";
  }


  ###  Print the rest of the HTML.
  print <<EOF;
  </TR>

  <TR $cb> <TD COLSPAN="5">&nbsp;</TD> </TR>

  <TR $cb>
    <TD WIDTH="35%"><DIV CLASS="nbody"><B>$new_password_1_HELP</TD>
    <TD WIDTH="10%"><INPUT TYPE="PASSWORD" NAME="user_pass1" SIZE="10"></TD>
    <TD WIDTH="10%">&nbsp;</TD>
    <TD WIDTH="35%"><DIV CLASS="nbody"><B>$new_password_2_HELP</TD>
    <TD WIDTH="10%"><INPUT TYPE="PASSWORD" NAME="user_pass2" SIZE="10"></TD>
  </TR>

  <TR $cb> <TD COLSPAN="5">&nbsp;</TD> </TR>

  <TR $cb>
    <TD ALIGN="LEFT" VALIGN="BOTTOM" COLSPAN="2"><DIV CLASS=nbody>
      <INPUT TYPE="SUBMIT" NAME="fcn" VALUE="Abort and Log Out">
    </TD>
    <TD>&nbsp;</TD>
    <TD ALIGN="RIGHT" VALIGN="BOTTOM" COLSPAN="2"><DIV CLASS=nbody>
      <INPUT TYPE="SUBMIT" VALUE="Update Password">
    </TD>
  </TR>

</TABLE></CENTER></FORM>
EOF


  ###  Print obligatory footer.
  &ryanFooter("index.cgi");



  ### ##########################################################################
  sub DoesUserHaveSmbpassEntry() {
    open SMBPASSWD, "/etc/samba/smbpasswd";
      while (my $line = <SMBPASSWD>) { if ($line =~ m/^$_[0]\:/) { return 1; } }
    close SMBPASSWD;

    return 0;
  }

