#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: do_changepass.cgi,v 1.1.1.2 2001/12/11 06:50:38 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ### Include the standard library, PAM module, and populate %in.
  use Authen::PAM;
  require './userpass-lib.pl';
  &ReadParse();

  ###  If we want to update the password...
  if (!$in{'fcn'}) {

    $pam_username  =  $ENV{'REMOTE_USER'};
    $pam_password  =  $in{'user_curpass'};
    $user_pass1    =  $in{'user_pass1'};
    $user_pass2    =  $in{'user_pass2'};


    ### Start the PAM session, and set our username.
    $prv1 = pam_start("WebTool", $pam_username, \&pam_conv_func, $pamh);
    $prv2 = pam_set_item($pamh, PAM_USER, $pam_username);


    ### Define our state as authentication and execute.
    $pam_state = "AUTHENTICATE";
    $prv3 = pam_authenticate($pamh, 0);


    ###
    ###  Input validation.
    ###
      if (!$pam_password) {
        &PrintError("Please enter your old password."); exit;
      }
      elsif ($prv3 != 0) {
        &PrintError("Your 'Old Password' is incorrect.  Please reenter."); exit;
      }
      elsif (!$user_pass1 || !$user_pass2) {
        &PrintError("Please enter a new password in both fields."); exit;
      }
      elsif ($user_pass1 ne $user_pass2) {
        &PrintError("The two passwords do not match.  Please reenter."); exit;
      }


   ###  Finally, lets change our password and end our session.
   $prv4 = pam_chauthtok($pamh, 0);
   $prv5 = pam_end($pamh, 0);


    ###
    ### Now sync the users SMB password, if we are told to.
    ###
    if ($in{'sync_smbpasswd'}) {
      open SMB, "| /usr/bin/smbpasswd -s -a $pam_username";
        print SMB "$user_pass1\n";
        print SMB "$user_pass1\n";
      close SMB;
    }
  }


  ### Log out.
  open(LOGOUT, ">$miniserv{'logout'}");
    printf LOGOUT "%d\n", $ENV{'HTTP_USER_AGENT'} =~ /MSIE\s+4\./ ? 2 : 1;
  close(LOGOUT);


  ### Whisk us away somewhere.
  &redirect("/session_login.cgi?logout=1");



### ##################################################### ###
### The PAM conversation function for interactive logins. ###
### ##################################################### ###
sub pam_conv_func {
  my @res;

  while ( @_ ) {
    my $code = shift;
    my $msg = shift;
    my $ans = "";


    if ($code == &PAM_PROMPT_ECHO_OFF) {
      if ($pam_state eq "AUTHENTICATE") {
        $pam_state = "CHAUTH-AUTHEN";
        $ans = $pam_password;
      }

      elsif ($pam_state eq "CHAUTH-AUTHEN") {
        $pam_state = "CHAUTHTOK";
        $ans = $user_pass1;
      }
      else { $ans = $user_pass1; }
    }
    else {
      &PrintError("Error:  $msg");
      exit;
    }

    push @res, &PAM_SUCCESS;
    push @res, $ans;
  }

  get_out;
  push @res, &PAM_SUCCESS;
  return @res;
}

###  TEMP TEMP TEMP  ###
### return ("you are not registered in the password file");
### return ("it is based on your username");
### return ("it is based upon your password entry");
### return ("it is derived from your password entry");
### return ("it's derived from your password entry");
### return ("it is derivable from your password entry");
### return ("it's derivable from your password entry");
### return ("it's WAY too short");
### return ("it is too short");
### return ("it does not contain enough DIFFERENT characters");
### return ("it is all whitespace");
### return ("it is too simplistic/systematic");
### return ("it looks like a National Insurance number.");
### return ("it is based on a dictionary word");
### return ("it is based on a (reversed) dictionary word");
###  TEMP TEMP TEMP  ###
