#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: do_download_key.cgi,v 1.1.1.1 2001/12/11 06:50:38 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut


  ###  Import our library routines.
  require './userpass-lib.pl';
  &ReadParse();

  ###  Setup local variables.
  my ($KEYFILE, $hostname, $username);

  $hostname  =  &get_system_hostname();
  $username  =  $ENV{'REMOTE_USER'};

  if ($ENV{'REMOTE_USER'} eq "root") {
    $KEYFILE   =  "/root/.ssh/$in{'filename'}";
  }
  else {
    $KEYFILE   =  "/home/$username/.ssh/$in{'filename'}";
  }



  ###  Save our current ID's and get our target ID's.
  my ($UID, $GID, $s_UID, $s_EUID, $s_GID, $s_EGID);

  $s_UID  = $<; $s_EUID = $>; $UID = undef;
  $s_GID  = $(; $s_EGID = $); $GID = undef;

  setpwent();
    while (my @u = getpwent()) {
      if ($u[0] eq $username) { $UID = $u[2]; $GID = $u[3]; }
    }
  endpwent();


  ###  Throw an error if we don't have $UID and $GID.
  if ( (! defined($UID)) || (! defined($GID)) ) {
    &PrintError("Unable to find your UID and GID. Contact your administrator.");
    exit;
  }


  ###
  ###  Drop privileges.
  ###
  $< = $UID;        $( = $GID;
  $) = "$GID $GID"; $> = $UID;


  ###  If this is not a file then exit.
  if (! -f $KEYFILE) { exit; }

  ### Print the headers.
  print "Content-type:  application/pkcs7-mime\n";
  print "Content-Disposition: attachment; filename=\"identity-$username-$hostname.key\"\n\n";

  ### Open key and send it to user.
  open KEY, $KEYFILE; while (<KEY>) { print $_; } close KEY;

  ### Go home.
  exit;
