#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: do_upload_key.cgi,v 1.1.1.1 2001/12/11 06:50:38 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut


  ###  Import our library routines.
  use POSIX qw(tmpnam);
  use Fcntl;			###  Needed for O_NOFOLLOW?

  require 'userpass-lib.pl';
  &ReadParseMime();


  ###  Setup local variables.
  my ($tmp_key, $AUTHORIZED_KEYS, $dot_ssh);

  if ($ENV{'REMOTE_USER'} eq "root") {
    $AUTHORIZED_KEYS  =  "/root/.ssh/authorized_keys";
    $dot_ssh          =  "/root/.ssh";
  }
  else {
    $AUTHORIZED_KEYS  =  "/home/$ENV{'REMOTE_USER'}/.ssh/authorized_keys";
    $dot_ssh          =  "/home/$ENV{'REMOTE_USER'}/.ssh";
  }
  $tmp_key          =  POSIX::tmpnam();


  ###  Save our current ID's and get our target ID's.
  my ($UID, $GID, $s_UID, $s_EUID, $s_GID, $s_EGID);

  $s_UID  = $<; $s_EUID = $>; $UID = undef;
  $s_GID  = $(; $s_EGID = $); $GID = undef;

  setpwent();
    while (my @u = getpwent()) {
      if ($u[0] eq $ENV{'REMOTE_USER'}) { $UID = $u[2]; $GID = $u[3]; }
    }
  endpwent();


  ###  Throw an error if we don't have $UID and $GID.
  if ( (! defined($UID)) || (! defined($GID)) ) {
    &PrintError("Unable to find your UID and GID. Contact your administrator.");
    exit;
  }


  ###
  ###  Drop privileges.
  ###
  $< = $UID;        $( = $GID;
  $) = "$GID $GID"; $> = $UID;


  ###  If $HOME/.ssh or $HOME/.ssh/authorized_keys DNE, create them.
  if ( (! -d $dot_ssh) || (! -f $AUTHORIZED_KEYS) )
  {
    umask 0077;
    mkdir $dot_ssh, 0700;
    open AK, ">$AUTHORIZED_KEYS"; close AK;
  }


  ###  Make sure somebody did not upload a private key (props to JeffB ;))
  if ($in{'pubkey'} =~ m/^SSH\ PRIVATE\ KEY/) {
    &PrintError("Please upload a PUBLIC key, not a PRIVATE key."); exit;
  }

  ###  Write the key to a temporary file and verify its integrity.
  umask 0077; open TMP, ">$tmp_key"; print TMP $in{'pubkey'}; close TMP;
  system "ssh-keygen -l -f $tmp_key > /dev/null 2>&1";
    if ($?) {
      &PrintError("Invalid public key file.");
      unlink $tmp_key;
      exit;
    }
  unlink $tmp_key;


  ###  Append the new key and sanitize the permissions.
  sysopen AKEYS, $AUTHORIZED_KEYS, O_WRONLY | O_CREAT | O_APPEND | O_NOFOLLOW;
    print AKEYS $in{'pubkey'};
  close AKEYS;

  chmod 0700, $dot_ssh;
  chmod 0600, $AUTHORIZED_KEYS;


  ###
  ###  Restore privileges.
  ###
  $> = $s_EUID; $) = $s_EGID;
  $( = $s_GID;  $< = $s_UID;


  ###  Go back to the key management index.
  &redirect("keyring.cgi");
