#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: keyring.cgi,v 1.1.1.1.4.1 2003/04/14 20:18:28 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut


  ###  Import our library routines.
  require 'userpass-lib.pl';

  ###  Setup local variables.
  my ($AUTHORIZED_KEYS, $lineno);

  if ($ENV{'REMOTE_USER'} eq "root") {
    $AUTHORIZED_KEYS  =  "/root/.ssh/authorized_keys";
    $lineno           =  0;
  }
  else {
    $AUTHORIZED_KEYS  =  "/home/$ENV{'REMOTE_USER'}/.ssh/authorized_keys";
    $lineno           =  0;
  }


  ###  Set up our help links.
  $pubkey_help     = &hlink("Public Key File", "sshd_pubkey", "help");
  $Filename_help   = &hlink("Filename", "sshd_filename", "help");
  $Comment_help    = &hlink("Description", "sshd_comment", "help");
  $Passphrase_help = &hlink("Passphrase", "sshd_passphrase", "help");


  ### Print obligatory header.
  &header("User Authentcation Management :: Secure Shell Key Management", "");

  ###  Print the HTML.
  print <<EOF;
<P><CENTER>
<TABLE BORDER=0 WIDTH="620" CELLPADDING=0 CELLSPACING=0>
  <TR $tb>
    <TD COLSPAN=2><DIV CLASS=ttitle><B>Secure Shell Key Management</B></TD>
  </TR>

  <TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
    Below you can view, generate, upload, and delete SSH keys.
  </TD></TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD COLSPAN="4">
          <DIV CLASS="thead"><B>Keys In Your Keyring</B></DIV>
        </TD>
      </TR>

EOF

  ###  Print out each key's fingerprint and a [ Remove ] link.
  open KG, "ssh-keygen -l -f $AUTHORIZED_KEYS |" if ( -f $AUTHORIZED_KEYS);
    while (<KG>)
    {
      ###  Catch the case where we have an empty file.
      if ($_ =~ m/not\ a\ valid\ key\ file\./) { next; }

      chomp;
      $lineno++;

      my ($size, $fprint, $comment);

      ($size, $fprint, $comment)  =  split /\ /, $_, 3;

      if ($lineno == 1)
      {
        print "      <TR $cb>\n";
        print "        <TD><DIV CLASS=\"nbody\"><B>Key&nbsp;Size</B></DIV></TD>\n";
        print "        <TD><DIV CLASS=\"nbody\"><B>Fingerprint</B></DIV></TD>\n";
        print "        <TD COLSPAN=\"2\"><DIV CLASS=\"nbody\"><B>Comment</B></DIV></TD>\n";
        print "      </TR>\n\n";
      }

      print "      <TR $cb>\n";
      print "        <TD><DIV CLASS=\"nbody\">$size</DIV></TD>\n";
      print "        <TD><DIV CLASS=\"nbody\">$fprint</DIV></TD>\n";
      print "        <TD><DIV CLASS=\"nbody\">$comment</DIV></TD>\n";
      print "        <TD><DIV CLASS=\"nbody\"><B>\n";
      print "          <A HREF=\"remove_key.cgi?lineno=$lineno\">[&nbsp;Remove&nbsp;]</A>\n";
      print "        </B></DIV></TD>\n";
      print "      </TR>\n\n";

    }
  close KG;

  if (! $lineno)
  {
      print "      <TR $cb>\n";
      print "        <TD COLSPAN=\"4\"><DIV CLASS=\"nbody\"><B>No keys are currently in place.</B></DIV></TD>\n";
  }

print <<EOF;
      </TR>
      </TABLE>
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <FORM ACTION="do_upload_key.cgi" METHOD="POST" ENCTYPE="multipart/form-data">
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD COLSPAN="2">
          <DIV CLASS="thead"><B>Upload a Public Key</B></DIV>
        </TD>
      </TR>

  <TR $cb>
    <TD COLSPAN=2><DIV CLASS=nbody>
      To upload a local public key, click on the "Browse..." button and select
      it from the directory on your local system
    </TD>
  </TR>
      <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$pubkey_help</B></A></TD>
        <TD><DIV CLASS="tbody"><INPUT TYPE="file" NAME="pubkey"></TD>
      </TR>

  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT">
      <DIV CLASS="nbody"><INPUT TYPE="Submit" VALUE="Upload Key">
    </TD>
  </TR>
      </TABLE>
      </FORM>
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <FORM ACTION="ssh-keygen_user.cgi">
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD COLSPAN="2">
          <DIV CLASS="thead"><B>Generate a New Keypair</B></DIV>
        </TD>
      </TR>


  <TR $cb>
    <TD COLSPAN=2><DIV CLASS=nbody>
      After clicking on "Generate Key" you will be prompted to save the
      private key to your computer.  After you do this you will be able to ssh
      into the machine as user 'Username', using the key and the provided
      passphrase.
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $cb>
    <TD><DIV CLASS="nbody"><B>$Filename_help</B></DIV></TD>
    <TD><INPUT TYPE="TEXT" NAME="Filename" SIZE="15" MAXLENGTH="15"></TD>
  </TR>

  <TR $cb>
  <TR $cb>
    <TD><DIV CLASS="nbody"><B>$Comment_help</B></DIV></TD>
    <TD><INPUT TYPE="TEXT" NAME="Comment" SIZE="40"></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS="nbody"><B>$Passphrase_help</B></A></TD>
    <TD><INPUT TYPE="PASSWORD" NAME="Passphrase1" SIZE="40"></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS="nbody"><B>Passphrase (again)</B></A></TD>
    <TD><INPUT TYPE="PASSWORD" NAME="Passphrase2" SIZE="40"></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT">
      <DIV CLASS="nbody"><INPUT TYPE="Submit" VALUE="Generate Keypair">
    </TD>
  </TR>



      </TABLE>
    </TD>
  </TR>
  <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>
</TABLE>
</CENTER><P>
EOF

  ### Print obligatory footer.
  &ryanFooter("index.cgi");
