#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: remove_key.cgi,v 1.1.1.1 2001/12/11 06:50:38 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut


  ###  Import our library routines.
  require 'userpass-lib.pl';
  &ReadParse();


  ###  Set up local variables.
  my ($AUTHORIZED_KEYS);

  if ($ENV{'REMOTE_USER'} eq "root") {
    $AUTHORIZED_KEYS  =  "/root/.ssh/authorized_keys";
  }
  else {
    $AUTHORIZED_KEYS  =  "/home/$ENV{'REMOTE_USER'}/.ssh/authorized_keys";
  }



  ###  Save our current ID's and get our target ID's.
  my ($UID, $GID, $s_UID, $s_EUID, $s_GID, $s_EGID);

  $s_UID  = $<; $s_EUID = $>; $UID = undef;
  $s_GID  = $(; $s_EGID = $); $GID = undef;

  setpwent();
    while (my @u = getpwent()) {
      if ($u[0] eq $ENV{'REMOTE_USER'}) { $UID = $u[2]; $GID = $u[3]; }
    }
  endpwent();


  ###  Throw an error if we don't have $UID and $GID.
  if ( (! defined($UID)) || (! defined($GID)) ) {
    &PrintError("Unable to find your UID and GID. Contact your administrator.");
    exit;
  }


  ###
  ###  Drop privileges.
  ###
  $< = $UID;        $( = $GID;
  $) = "$GID $GID"; $> = $UID;


  ###  Do the deed.
  $lref  =  &read_file_lines($AUTHORIZED_KEYS);
  splice @$lref, $in{'lineno'} - 1, 1;
  &flush_file_lines();


  ###  Go back to the key management index.
  &redirect("keyring.cgi");
